functor
import
   LogTrace
   Tk
   Application
   System
   Compiler
   Open
   Browser
   Colour
define
   ColCell = {NewCell Colour.list}
   Colors =  fun{$}
		C = {Access ColCell} in
		{Assign ColCell C.2}
		C.1
	     end
   T = {New Tk.toplevel tkInit(title:"OzMessageTrace")}
   LT = {New LogTrace.logTraceClass tkInit(parent:T)}
   {Tk.batch [grid(row:0 column:0 LT sticky:news)
	      grid(rowconfigure T 0 weight:1)
	      grid(columnconfigure T 0 weight:1)
	     ]}	      
   Args ={Application.getArgs list}
   if Args == nil then 
      {System.showInfo "The LogTool must be called as\n"#
       "  logTool <file 1> ... <file n>"}
      {Application.exit 0}
   end
   {List.forAllInd Args
    proc{$ Ind S}
       O = {New class $ from Open.file Open.text end  init(name:S)}
       fun{ReadFile}
	  case {O getS($)} of false then nil
	  elseof Line then
	     V in
	     try
		V = {Compiler.virtualStringToValue Line}
	     catch _ then
		V = string(Line)
	     end
	     V|{ReadFile}
	  end
       end
       ListOfEvents
       NodeId
       UnNumMsgDB = {NewDictionary}
       
       fun{UniqueMsgId Type To From}
	  MsgTypeDB
	  MsgNum
	  Num
       in
	  MsgTypeDB = {CondSelect UnNumMsgDB Type {NewDictionary}}
	  UnNumMsgDB.Type:=MsgTypeDB
	  MsgNum = {CondSelect MsgTypeDB To 0} + 1
	  MsgTypeDB.To:=MsgNum
	  {VirtualString.toAtom MsgNum#Type#From}
       end
    in
       {System.printInfo "Loading "#S#" ..."}
       ListOfEvents = {ReadFile}
       {System.printInfo " length: "#{Length ListOfEvents}}
       NodeId = ({List.dropWhile ListOfEvents
		  fun{$ S}
		     {Label S} \= transmit andthen
		     {Label S} \= received
		  end}.1).2
       {LT addNode(NodeId  {Colors})}
       {ForAll ListOfEvents
	proc{$ E}
	   case E of string(L) then 
	      {LT string('from':NodeId msg:L)}
	   elseof send(...) then
	      {LT string('from':NodeId msg:E)}
	   elseof received(conn_present ...) then
	      {LT string('from':NodeId msg:E)}
	   elseof received(conn_negotiate ...) then
	      {LT string('from':NodeId msg:E)} 

	   elseof transmit(conn_present ...) then
	      {LT string('from':NodeId msg:E)}
	   elseof accept(Local Remote Time) then
	      MsgTypeDB
	      MsgNum
	      Num
	      Type = accept
	   in
	      MsgTypeDB = {CondSelect UnNumMsgDB Type {NewDictionary}}
	      UnNumMsgDB.Type:=MsgTypeDB
	      MsgNum = {CondSelect MsgTypeDB Remote 0} + 1
	      MsgTypeDB.Remote:=MsgNum
	      Num ={VirtualString.toAtom MsgNum#conn_negotiate#Remote}
	      {LT receive('from':Remote to:Local  nr:Num msg:r(src:Local dest:Remote
							       accept num:Num time:Time))}
	   elseof transmit(conn_negotiate Local Remote _ Time) then
	      MsgTypeDB
	      MsgNum
	      Num
	      Type = conn_negotiate
	   in
	      MsgTypeDB = {CondSelect UnNumMsgDB Type {NewDictionary}}
	      UnNumMsgDB.Type:=MsgTypeDB
	      MsgNum = {CondSelect MsgTypeDB Remote 0} + 1
	      MsgTypeDB.Remote:=MsgNum
	      
	      Num ={VirtualString.toAtom MsgNum#Type#Local}
	      
	      {LT send('from':Local to:Remote nr:Num
		       msg:r(src:Local dest:Remote conn_negotiate  num:Num time:Time))}
	   elseof received(Type From To 0 Time) then
	      Num = {UniqueMsgId Type To To}	      

	   in
	      {LT receive('from':To to:From nr:Num
			  msg:r(src:From dest:To Type num:Num tim:Time))}
	   elseof received(Type From To Num Time) then
	      {LT receive('from':To to:From nr:Num
			  msg:r(src:From dest:To Type num:Num time:Time))}
	   elseof transmit(Type From To 0 Time) then
	      Num = {UniqueMsgId Type To From}
	   in
	      {LT send('from':From to:To nr:Num msg:r(src:From dest:To
						      Type num:Num time:Time))}
	   elseof transmit(Type From To Num Time) then
	      {LT send('from':From to:To nr:Num msg:r(src:From dest:To
						      Type num:Num time:Time))}
	   else
	      {LT string('from':NodeId msg:E)}
	   end
	end}
       {System.showInfo " done"}
    end}
   {System.show solving}
   {LT solve}
   {System.show solveDone}
end
